; DIGITAL SERVO CONTROLLER		Servo Config Parameters
; ------------------------------------------------------------------------------
 
      list    p=12f683, r=dec, n=80, st=off
      #include <p12f683.inc>
 
; configuration registers to be embedded in the hex file
 
  __config (_MCLRE_OFF & _pwrte_on &_CP_OFF & _WDT_off & _INTRC_OSC_NOCLKOUT)

; suppress bank selection warning messages
	ERRORLEVEL      -302

				; *** COMPILE OPTIONS *** ;
; The remaining defines configure build options to include/disclude sections of
; code from being included in the binary. Each option when defined is defined as
; an int that becomes the bit set in the BUILD_OPIONS command (do not change this bit).
; define ADC_10BIT to use the ful 10bits of the ADC. causes little effect
; on cycle time, but should improve PID accuracy by 4. (Will require PID
; retuning!)

#define   ADC_10BIT                  0x01
;#define  PID_16BIT                  0x02
;#define  DISABLE_OUTPUT_ON_STARTUP  0x04 
;#define   EEPROM_LOAD_ON_STARTUP     
;#define   EEPROM_ASYNC_SAVE
;#ifdef    EEPROM_ASYNC_SAVE
;#define   EEPROM_NO_SYNC_WRITE
 

; if defined, the PID algorithm will not scale the final PID output value. This last 
; division is somewhat redundant considering you can calculate Kp,Ki,Kd coefficients 
; that would make Kpid=1. Removing this extra division allows you to increase the
; controller bandwidth. 

;#define  PID_NO_OUTPUT_COEFFICIENT  0x08

; these are the PID coefficient default values, Kp,Ki,Kd coefficients include the Kpid
; division when Kpid is disabled.
;---------------------------------------------------
;#ifdef PID_NO_OUTPUT_COEFFICIENT
;#define PID_DEFAULT_KP		0x04
;#define PID_DEFAULT_KI		0x20
;#define PID_DEFAULT_KD		0x20
;#define PID_DEFAULT_KPID	0x01
;#else
;--------------------------------------------------
;#if ADC_10BIT
;#define PID_DEFAULT_KP		0x03     ; 10 bit
;#define PID_DEFAULT_KI		0x20
;#define PID_DEFAULT_KD		0x20
;#define PID_DEFAULT_KPID	0x0a
;#else
;#define PID_DEFAULT_KP		0x04     ; 8 bit
;#define PID_DEFAULT_KI		0x20
;#define PID_DEFAULT_KD		0x01
;#define PID_DEFAULT_KPID	0x04
;#endif
;--------------------------------------------------
;#endif

; the default sample timer reload value. Determines the frequency/bandwidth of the
; PID loop. Each time the timer wraps, it causes an ADC to occur and the PID loop to
; be executed. This is the default value, the real clock can be stored in EEPROM or
; can also be auto adjusted based on overruns occurring.
;  Note: this is the high-byte portion of the TMR1H:TMR1L, loading TMR1L is too fine
; a granularity to be useful.

#ifdef    PID_NO_OUTPUT_COEFFICIENT
#define   SAMPLETIMER_RELOAD_DEFAULT	0x01
#else
#define   SAMPLETIMER_RELOAD_DEFAULT	0x02
#endif

; enable this to automatically lower the sample clock when servo overruns occur, this
; is a good way to determine max sample clock under in-system conditions. This can
; also be enabled temporarily using a servo option

#define AUTO_ADJUST_BANDWIDTH		0x10

; if enabled, servo code will include a speed limiter. The speed limit of the servo
; will be stored in the SERVO_SPEED register.

;#define SPEED_LIMITER			0x20

 
 