; DIGITAL SERVO CONTROLLER					Register Locations
; ---------------------------------------------------------------------------------------
#define AN000           GPIO,0       ; GP0     pin 7
#define AN001           GPIO,1       ; GP1     pin 6
#define CCP5            GPIO,2       ; GP2/CCP pin 5
#define Signal_In       GPIO,3       ; GP3     pin 4
#define CCWdrv          GPIO,4       ; GP4     pin 3
#define CWdrv           GPIO,5       ; GP5     pin 2
 

SERVO_CP      EQU 		0x60    ; the desired (target) servo position
SERVO_CPH     EQU		0x61    ; servo's measured position
SERVO_SPEED   EQU		0x62    ; registers value limits the servo's top speed
SERVO_CURRENT EQU	       	0x63    ; servo's measured current, related to servo force output
SERVO_STATUS  EQU	        0x64    ; servo status register
PGM_STAT      EQU               0x65

#define PPM_CAP        PGM_STAT,0
#define T1Expired      PGM_STAT,1

#define	SSF_PIDRUN		0	; set if PID loop is computing
#define	SSF_FREADY		1	; function complete, result ready
#define SSF_OE			2	; servo output enable
#define	SSF_OFF			3	; turns ADC conversion and output off
#define	SSF_OBSTACLE 		4	; if set, servo has hit an obstacle
#define	SSF_ENEG		5	; sign of the proportional error
#define	SSF_ADC0		6	; ADC least significant bit 0&1
#define	SSF_ADC1		7

SERVO_E	           EQU		0x66    ; computed Proportional Error, the sign 
SERVO_EH           EQU          0X67    ; if this value is in the option register
                                                ; boolean run-time options for the servo
SERVO_OPTIONS	   EQU	        0x68	; servo options register

#DEFINE SO_AUTO_ADJUST_BANDWIDTH 	0	; adjust bandwidth when pid overruns occur

SERVO_OVERRUNS_H   EQU   	0x69	        ; free-running counter of servo overruns. The number	
SERVO_OVERRUNS_L   EQU   	0x6A            ; of times PID loop calcs extended beyond sample timer

; free-running performance counter that is incremented each time the PID loop
; is executed. In theory this should be incremented n times/sec where:
;    n = Tosc / 4 / Tsc
;    Tosc -> typically 20Mhz, 
;    Tsc -> sample clock period determined by SERVO_CLOCK 

SERVO_ITER_H	    EQU     	        0x6B		; ticks for each PID iteration
SERVO_ITER_L	    EQU     	        0x6C

; The sample clock reload value
;    to convert to Hz use Tosc / 1024 / SERVO_CLOCK
;    where Tosc is typically 20MHz

#define SERVO_CLOCK			0x6D	
	
SERVO_DP           EQU                  0X6E
SERVO_DPH          EQU                  0X6F
RC_PULSEL          EQU                  0x6E
RC_PULSEH          EQU                  0x6F 
;-------------------------------------------------------------------------------------------
; Accumulators for 16bit math routines
#define ACCa	  			0x78
#define ACCaLO  			0x79
#define ACCb	  			0x7a
#define ACCbLO  			0x7b

; variables used to store state while in isr (DO NOT MOVE)
;   These are placed within special area 0x70-0x7f which is aliased accross all
; memory banks (i.e. these registers must be accessible no matter the bank switches)
;;ISR_W					equ	0x70	; must be in range of [0x70 - 0x7f]
;;ISR_STATUS				equ	0x71	; so they can be accessed through all
;;ISR_PCLATH				equ	0x72	; memory banks.

; Base memory address of PID variables and history buffer
; memory size is:
;     (8Bits)  10 bytes + PID_HMASK+1
;     (16Bits) 19 bytes + (PID_HMASK+1)*2
#define PID_BASE			0x20			; base of PID data block
											; memory size: (8bit) 8 bytes + bufferSize, (16bit) 16 bytes + bufferSize*2
#define PID_HMASK			0x0f			; determines history size using masking (efficiency)

 